package util;
import java.awt.*;

/*
 * Example:
 *   CGRectangle myRotRe = new CGRectangle (new Point(200,100),new Point(220,110));
 *   g.setColor(Color.black);   g.fillPolygon (myRotRe.rotateIt(0));
 *   g.setColor(Color.green);   g.fillPolygon (myRotRe.rotateIt(45));
 */

/* This class produces rotated rectangles as polygons.
 */

public class CGRectangle {
	
	private int xl,yl,xr,yr;
 
	public CGRectangle (Point p, Point q){
		this.xl=Math.min(p.x,q.x);
		this.xr=Math.max(p.x,q.x);
		this.yl=Math.min(p.y,q.y);
		this.yr=Math.max(p.y,q.y);
	}
 
	private Point rotatePoint (Point p, double winkel){
		double bogen = 2*Math.PI*winkel/360;
		return new Point((int)(Math.cos(bogen)*p.x-Math.sin(bogen)*p.y),(int)(Math.sin(bogen)*p.x+Math.cos(bogen)*p.y));
	}
 
	public Polygon rotateIt (double angle, float pX, float pZ){
		int [] x_corner_d = new int [4];
		int [] y_corner_d = new int [4];
		
		int centerX = (int)(pX*1024);
		int centerY = (int)(pZ*1024);
		
		// Debug Output
		// System.out.println("Drehmittelpunkt: " + centerX + "/" + centerY);
		
		x_corner_d[0]=rotatePoint(new Point(xl-centerX,centerY-yl),angle).x+centerX;
		y_corner_d[0]=centerY-rotatePoint(new Point(xl-centerX,centerY-yl),angle).y;
		
		x_corner_d[1]=rotatePoint(new Point(xl-centerX,centerY-yr),angle).x+centerX;
		y_corner_d[1]=centerY-rotatePoint(new Point(xl-centerX,centerY-yr),angle).y;
		
		x_corner_d[2]=rotatePoint(new Point(xr-centerX,centerY-yr),angle).x+centerX;
		y_corner_d[2]=centerY-rotatePoint(new Point(xr-centerX,centerY-yr),angle).y;
		
		x_corner_d[3]=rotatePoint(new Point(xr-centerX,centerY-yl),angle).x+centerX;
		y_corner_d[3]=centerY-rotatePoint(new Point(xr-centerX,centerY-yl),angle).y;
		
		return new Polygon (x_corner_d,y_corner_d,4);
	}
}